#include "bootloader.h"
/* Autogenerated */
#include "splash-screen.h"

#include "GUI_Paint.h"
#include "display.h"

/*
 * "Decompress" splash-screen image.  The algorithm works as follows:
 *
 * Each byte encodes up to 127 pixels in either white or black.  The most
 * significant bit determines the color, the remaining 7 bits determine the
 * amount.
 */
static void bootloader_display_splash(void)
{
	int idx = 0;

	for (int i = 0; i < sizeof(splash); i++) {
		uint16_t color = (splash[i] & 0x80) ? 0xffff : 0x0000;
		uint8_t length = splash[i] & 0x7f;

		for (int j = 0; j < length; j++) {
			uint16_t x = idx % 160;
			uint16_t y = idx / 160;
			Paint_SetPixel(x, y, color);
			idx++;
		}
	}

	LCD_Update();
}

/*
 * Initialize the display.
 */
void bootloader_display_init(void)
{
	bootloader_display_splash();
}

/*
 * Show the bootloader version on the display.
 */
void bootloader_display_header(void)
{
	Paint_Clear(0x0000);
	Paint_DrawString_EN(0, 16 * 0, "Bootloader", &Font16, 0x0000, 0xffff);
	Paint_DrawString_EN(0, 16 * 1, __DATE__, &Font16, 0x0000, 0xffff);
	LCD_Update();
}

/*
 * Display a line of text on the display.
 */
void bootloader_display_line(int line, char *string, uint16_t color)
{
	Paint_DrawString_EN(0, 16 * line, string, &Font16, 0x0000, color);
	LCD_Update();
}
